/*--------------------------------------------------------------------------------------------------------------------
[Plugin] FG Context Clip Menu  (by Speedmaster)
File Name : FG_Context_Clip_Menu.ahk
version: 1.5.01
topic: https://www.autohotkey.com/boards/viewtopic.php?p=506077#p506077
Help:
how to install this plugin ?
1 download FG ScreenClipper at https://www.autohotkey.com/boards/viewtopic.php?p=506077#p506077
2 put this plugin in the Lib folder of the main script
3 insert #Include FG_Context_Clip_Menu.ahk in the INCLUDE SECTION of the main script ---> RUN_ScreenCLip.ahk

Note this plugin has internal default shortcuts (see below) that you can change 
or migrate in the #ifwinactive section of the main run script  (Run_screenclip.ahk)
*/---------------------------------------------------------------------------------------------------------------------

;DEFAULT SHORTCUT ---------------------------------------------------
; You will find the default internal shortcut (rbutton::) at the end of this script. 
; Note: Internal default shortcuts for menu plugins are by default desactivated.


;------------------ Simplified Menu---------------------------------------------------------------------------

Menu, FG_Context_Clip_2, add, COPY:  &Clipboard										, FG_Context_Clip_2_Handler
Menu, FG_Context_Clip_2, add, COPY:  Clipboard (with Border)						, FG_Context_Clip_2_Handler
Menu, FG_Context_Clip_2, add
Menu, FG_Context_Clip_2, add, SAVE:  &File											, FG_Context_Clip_2_Handler
Menu, FG_Context_Clip_2, add, SAVE:  File (with Border)								, FG_Context_Clip_2_Handler
Menu, FG_Context_Clip_2, add, SAVE:  File && Email									, FG_Context_Clip_2_Handler
Menu, FG_Context_Clip_2, add
Menu, FG_Context_Clip_2, add, OPEN :  Saved Images Folder     						, FG_Context_Clip_2_Handler
Menu, FG_Context_Clip_2, add, CLOSE:  Clip Image									, FG_Context_Clip_2_Handler


FG_Context_Clip_2_Handler(){
	global
		if (A_ThisMenuItemPos = 9) ; Close (destroy) Clip Image
		{ 
			 WinGet, Hwnd, ID, A
	         MaxGuis := SCW_Reg("MaxGuis"), i := SCW_Reg("StartAfter")		
        	Loop % MaxGuis {
	       	     if (SCW_Reg("G" ++i "#HWND") = hwnd) {
		    	     currentgui := i
		    	     break
		            }}	
			gui %currentgui%: destroy	
			FileDelete, % CacheFolder "\" currentgui ".png"          ; also remove cached image (if there is one)
		}
		
		Sleep 350	; Context Menu selection fades out and needs time to disappear before Clipping
		if  (A_ThisMenuItemPos = 1)		; Clipboard
			SCW_Win2Clipboard()
		else if (A_ThisMenuItemPos = 2)	; Clipboard with Border
			SCW_Win2Clipboard(0)
			else if (A_ThisMenuItemPos = 4) ; File
			SCW_Win2File(Settings_SavePath)
		else if (A_ThisMenuItemPos = 5) ; File with Border
			SCW_Win2File(Settings_SavePath,,0)
		else if (A_ThisMenuItemPos = 6) ; File & Email
		{
			File := SCW_Win2File(Settings_SavePath)
			Email_AttachFile(File)
		}
		else if (A_ThisMenuItemPos = 8) ; open saved images folder
			Run, % Settings_SavePath

		;~ MsgBox You selected %A_ThisMenuItemPos% - %A_ThisMenuItem% from the menu %A_ThisMenu%.
}

;------------------- Full Menu --------------------------------------------------------------------------------

Menu, FG_Context_Clip_1, add, COPY:  &Clipboard										, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, COPY:  Clipboard (with Border)						, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add
Menu, FG_Context_Clip_1, add, SAVE:  &PDF											, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, SAVE:  PDF (with Border)								, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, SAVE:  P&DF - Saved									, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, SAVE:  PDF - Saved (with Border)						, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add
Menu, FG_Context_Clip_1, add, SAVE:  &File											, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, SAVE:  File (with Border)								, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, SAVE:  File && Email									, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, SAVE:  File && Imgur									, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add, SAVE:  File`, Imgur && Email							, FG_Context_Clip_1_Handler
Menu, FG_Context_Clip_1, add
Menu, FG_Context_Clip_1, add
Menu, FG_Context_Clip_1, add, CLOSE:  Clip Image									, FG_Context_Clip_1_Handler

;~ Context Menu 1 handler (Right Click)
FG_Context_Clip_1_Handler(){
	global
		if (A_ThisMenuItemPos = 17) ; Close (destroy) Clip Image
		{ 
			 WinGet, Hwnd, ID, A
	         MaxGuis := SCW_Reg("MaxGuis"), i := SCW_Reg("StartAfter")		
        	Loop % MaxGuis {
	       	     if (SCW_Reg("G" ++i "#HWND") = hwnd) {
		    	     currentgui := i
		    	     break
		            }}	
			gui %currentgui%: destroy	
			FileDelete, % CacheFolder "\" currentgui ".png"          ; also remove cached image (if there is one)
		}
		Sleep 350	; Context Menu selection fades out and needs time to disappear before Clipping
		if  (A_ThisMenuItemPos = 1)		; Clipboard
			SCW_Win2Clipboard()
		else if (A_ThisMenuItemPos = 2)	; Clipboard with Border
			SCW_Win2Clipboard(0)
		else if (A_ThisMenuItemPos = 4) ; Clipboard to PDF
		{
			SCW_Win2Clipboard()
			Clipboard2Acrobat()
		}
		else if (A_ThisMenuItemPos = 5) ; Clipboard with Border to PDF
		{
			SCW_Win2Clipboard(0)
			Clipboard2Acrobat()
		}
		else if (A_ThisMenuItemPos = 6) ; Clipboard to PDF and Save
		{
			SCW_Win2Clipboard()
			Clipboard2Acrobat(Settings_SavePathPDF)
		}
		else if (A_ThisMenuItemPos = 7) ; Clipboard with Border to PDF and Save
		{
			SCW_Win2Clipboard(0)
			Clipboard2Acrobat(Settings_SavePathPDF)
		}
		else if (A_ThisMenuItemPos = 9) ; File
			SCW_Win2File(Settings_SavePath)
		else if (A_ThisMenuItemPos = 10) ; File with Border
			SCW_Win2File(Settings_SavePath,,0)
		else if (A_ThisMenuItemPos = 11) ; File & Email
		{
			File := SCW_Win2File(Settings_SavePath)
			Email_AttachFile(File)
		}
		else if (A_ThisMenuItemPos = 12) ; File & Imgur
		{
			File := SCW_Win2File(Settings_SavePath)
			URL := Imgur_Post(File, Settings_Imgur_Client)
			Clipboard := URL
		}
		else if (A_ThisMenuItemPos = 13) ; File, Imgur & Email
		{
			File := SCW_Win2File(Settings_SavePath)
			URL := Imgur_Post(File, Settings_Imgur_Client)
			Email_AttachFile(File, URL)
		}
		else if (A_ThisMenuItemPos = 16) ; open saved images folder
			Run, % Settings_SavePath		
		
		;~ MsgBox You selected %A_ThisMenuItemPos% - %A_ThisMenuItem% from the menu %A_ThisMenu%.
}



;~ ; DEFAULT SHORTCUTS ---------------------------------------------------
;~ #IfWinActive, ScreenClipperWindow ahk_class AutoHotkeyGUI
;~ Rbutton:: Menu, FG_Context_Clip_2, Show
;~ #IfWinActive
;~ ;----------------------------------------------------------------------