; file name: FG_Header.ahk
; version : 1.6
; FG_ScreenClip settings Header
; autors : Fanatic Guru, Speedmaster
;
; Requierd:
; Include in this order:
;          Lib\FG_Header.ahk
;          Lib\FG_ScreenClip.ahk
;		   Lib\FG_Context_Clip_Menu.ahk
;
;--------------- HELP for SCW_SetUp() --------------------------------------------
;	StartAfter - module will start to consume GUIs for screen clipping windows after specified GUI number. Default: 80
;	MaxGuis - maximum number of screen clipping windows. Default: 6
;	BorderAColor - Default: ff6666ff (ARGB format)
;	BorderBColor - Default: ffffffff (ARGB format)
;	DrawCloseButton - on/off draw "Close Button" on screen clipping windows. Default: 0 (off)
;	AutoMonitorWM_LBUTTONDOWN - on/off automatic monitoring of WM_LBUTTONDOWN message. Default: 1 (on)
;	SelColor - selection color. Default: Yellow
;	SelTrans - selection transparency. Default: 80
; -------------------------------------------------------------------------------

; ------------------- force running in 32 bit instead of 64 bit ---------------------------

if((A_PtrSize=8&&A_IsCompiled="")||!A_IsUnicode){ ;32 bit=4  ;64 bit=8
    SplitPath,A_AhkPath,,dir
    if(!FileExist(correct:=dir "\AutoHotkeyU32.exe")){
	    MsgBox error
	    ExitApp
    }
    Run,"%correct%" "%A_ScriptName%",%A_ScriptDir%
    ExitApp
    return
}

; ------------------- Change the default settings for the screen clipper here -------------

SCW_SetUp("MaxGuis.15 StartAfter.50 BorderAColor.ff6666ff BorderBColor.ffffffff DrawCloseButton.0 AutoMonitorWM_LBUTTONDOWN.1 SelColor.Yellow SelTrans.80")  

; INITIALIZATION - VARIABLES
;Obtain IMGUR API token value here: https://imgur.com/account/settings
global GuiNum  ;  to know the name (number) of the created gui this internal variable function name is made global.
Settings_Imgur_Client := "xxxxxxxxxxxxxxx"
Settings_SavePath := ".\Images - Screen Clipper\"					; the place where the images will be saved
RelativePath(Settings_SavePath)
Settings_SavePathPDF := ".\PDF - Screen Clipper\"                   ; the place where the pdfs will be saved
RelativePath(Settings_SavePathPDF)
Settings_Ini := A_ScriptFullPath ": Screen Clipper.ini"             ; Ini File in Script's Alternate Data Stream (requires NTFS)
Settings_Ini := A_ScriptDir "\Screen Clipper.ini"                   ; Normal Ini File
CacheFolder:= A_ScriptDir "\temp"                                   ; folder where temporary images are stored (please, do not put the last "\")
SCW_Reg("CacheFolder", Cachefolder)

; -------------------- Read Settings from Ini File ----------------------------------------
if FileExist(Settings_Ini)
{
	IniRead, Settings_Imgur_Client, %Settings_Ini%, Settings, Settings_Imgur_Client, %Settings_Imgur_Client%
	IniRead, Settings_SavePath, %Settings_Ini%, Settings, Settings_SavePath, %Settings_SavePath%
}

; ------------------- clear the cache folder ---------------------------------------------
zlist:={}
loop 99 {
	FileDelete, % SCW_Reg("cachefolder") "\" a_index ".png"
}

