; File Name: RUN_ScreenCLip.ahk
; version : 1.7
; Main Run file
; autors : Fanatic Guru, Speedmaster

#Requires AutoHotkey v1.1.1+

; INITIALIZATION - ENVIROMENT
; -------------------------------------------------------------------------------------
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#SingleInstance force  ; Ensures that only the last executed instance of script is running
; #NoTrayIcon  ; if you want no tray icon
Menu, tray, icon, %A_WinDir%\system32\mmcndmgr.dll,106  ; camera tray icon
; --------------------------------------------------------------------------------------
OnExit("ExitFGClipper")   ; clear the cache folder before exiting

;exit procedure
ExitFGClipper(){
global
loop 99
FileDelete, % CacheFolder "\" a_index ".png"         ; clear the cache folder
exitapp
}


; INCLUDE SECTION
; --------------------------------------------------------------------------------------
; -------------------- headers plugins
#Include lib\
#Include gdip_all.ahk               ; graphic library
#Include ImagePut.ahk               ; (for v1) graphic library
#Include FG_Header.ahk              ; change the default settings in this script.
#Include FG_ScreenClip.ahk          ; main script library
#Include FG_Context_Clip_Menu.ahk   ; there are 2 context menu in this file (full and basic)
;#Include JL_Shrink.ahk             ; double click to shrink or restore window size

; ------------------- footers plugins
;#Include SM_Borders.ahk            ; Press B to hide or show borders (toggle)
;#Include SM_RotateFlip.ahk			; Press R or Ctrl R to rotate current selected clip 90 or 180
;#Include SM_Vis2.ahk               ; Press T to OCR (with tesseract.exe) (by iseahound)
;#Include SM_HideShowAll.ahk        ; Press F12 to Hide / Show all clip images
;#Include SM_Duplicate.ahk          ; Press D to duplicate selected clip image
;#Include SM_AlwaysOnBottom.ahk     ; Press PageDown / PageUp to make selected clip always on bottom or restore always on top
;#Include SM_Resizer.ahk            ; Press Crtl + Mouse wheel or Numpad Add/Sub to resize
;#Include GK_OCR.ahk				; Press Y to use internal Windows 10 OCR   (win 10+ only)
;#Include SM_Grayscale.ahk			; Press G to toggle grayscale
;#Include SM_MoveClip.ahk			; Press arrow or ctrl arrow keys to move clip by 10 or 1 pixel
;#Include SM_Trans.ahk			    ; Press Shift + Mouse wheel to make clip image transparent. Not compatible with other plugins. Use plugin duplicate to restore.
;#Include SM_DrawShape.ahk			; Press P to activate drawing mode. Use Shift Ctrl and Alt + mouse to draw shapes. Press Ctrl + P to abort.
; ---------------------------------------------------------------------------------------


; HOTKEYS GLOBAL SECTION
; -----------------------------------------------
;
#Lbutton::		;	<-- Clip Image Only
	SCW_ScreenClip2Win(SetClipboard:=false)
return

#^Lbutton::	;	<-- Clip Image and Copy to Clipboard
	SCW_ScreenClip2Win(SetClipboard:=true)
return

#!Lbutton::		;	<-- Clip Image and Save to File
	Hwnd := SCW_ScreenClip2Win(SetClipboard:=false)
	SCW_Win2File(Settings_SavePath,Hwnd)
return

#^!Lbutton::	;	<-- Clip Image, Copy to Clipboard, and Save to File
	Hwnd := SCW_ScreenClip2Win(SetClipboard:=true)
	SCW_Win2File(Settings_SavePath,Hwnd)
return

; HOTKEYS IF_WIN_ACTIVE SECTION
; ---------------------------------------------------------------------------------------
#IfWinActive, ScreenClipperWindow ahk_class AutoHotkeyGUI

; REMOVE (DESTROY) SELECTED CLIP IMAGE
; ---------------------------------------------------------------------------------------
Esc::
WinGet, Hwnd, ID, A
MaxGuis := SCW_Reg("MaxGuis"), i := SCW_Reg("StartAfter")
   	Loop % MaxGuis {
        if (SCW_Reg("G" ++i "#HWND") = hwnd) {
	        currentgui := i
			break
		}}
	gui %currentgui%: destroy
	FileDelete, % CacheFolder "\" currentgui ".png"          ; also remove cached image (if there is one)
return

; RIGHT CLICK CONTEXT MENU
; ---------------------------------------------------------------------------------------
Rbutton:: Menu, FG_Context_Clip_2, Show

^c::				;	<-- (Screen Clipper) : Copy Active Clip to Clipboard  (true = remove borders)
	SCW_Win2Clipboard(true)
return
+^c::			;	<-- (Screen Clipper) : Copy Active Clip to Clipboard with Border (false = with borders)
	SCW_Win2Clipboard(false)
return
^s::				;	<-- (Screen Clipper) : Save Active Clip to File
	SCW_Win2File(Settings_SavePath)
return
+^s::			;	<-- (Screen Clipper) : Save Active Clip to File with Border
	SCW_Win2File(Settings_SavePath,,0)
return
#e::				;	<-- (Screen Clipper) : Save Active Clip to File and Email
	File := SCW_Win2File(Settings_SavePath)
	Email_AttachFile(File)
return

#IfWinActive
; -----------------------------------------------------------------------------------------------------------
